/* $Id: filename.c,v 1.3 2004/05/07 23:46:45 playfair Exp $
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License as
** published by the Free Software Foundation; either version 2 of the
** License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful, but
** WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
** 02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "filename.h"

void parse_filename(char *filename, filename_t **fn) {
    int filename_len, file_len;
    char *last_fsep, *last_esep, *file_start;

    filename_len = strlen(filename);

    last_fsep = strrchr(filename, FILE_SEP);
    last_esep = strrchr(filename, EXT_SEP);

    if (last_fsep) {
        (*fn)->dir = filename;
        (*fn)->dir_len = last_fsep - filename;
        (*fn)->file = last_fsep + 1;
    } else {
        (*fn)->dir = NULL;
        (*fn)->dir_len = 0;
        (*fn)->file = filename;
    }

    if (last_esep) {
        (*fn)->ext = last_esep + 1;
        (*fn)->ext_len = strlen(filename) - (last_esep - filename) - 1;
        (*fn)->file_len = (last_fsep)
            ? last_esep - last_fsep - 1
            : last_esep - filename;
    } else {
        (*fn)->ext = NULL;
        (*fn)->ext_len = 0;
        (*fn)->file_len = strlen((*fn)->file);
    }
}

char *get_outfile(filename_t *fn, char *destdir, char *ext) {
    int i;
    int dir_len = (destdir) ? strlen(destdir) : fn->dir_len;
    char *dir = (destdir) ? destdir : fn->dir;
    int ext_len = strlen(ext);
    int outfile_len = dir_len + fn->file_len + ext_len + 2 + 1;
    char *outfile = calloc(outfile_len, sizeof(char));

    strncpy(outfile, dir, dir_len);
    i = strlen(outfile);
    if (dir_len) outfile[i] = FILE_SEP;

    strncat(outfile, fn->file, fn->file_len);
    i = strlen(outfile);
    outfile[i] = EXT_SEP;

    strncat(outfile, ext, ext_len);

    return outfile;
}


/* EOF */
