/* $Id: HymnController.h,v 1.1 2004/05/10 00:16:59 playfair Exp $
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License as
** published by the Free Software Foundation; either version 2 of the
** License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful, but
** WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
** 02111-1307, USA.
*/

#import <Cocoa/Cocoa.h>
#import "hymn.h"

@interface HymnController : NSObject
{
    IBOutlet NSButton *clearButton;
    IBOutlet NSButton *convertButton;
    IBOutlet NSTextView *fileList;
    IBOutlet NSTextView *logMessages;
    IBOutlet NSPanel *logPanel;
    IBOutlet NSProgressIndicator *progress;
    IBOutlet NSTextField *status;
	NSMutableSet *infiles;
}
- (IBAction)orderFrontStandardAboutPanel:(id)sender;
- (IBAction)clear:(id)sender;
- (void)setFiles:(NSArray*)files;
- (IBAction)convert:(id)sender;
- (IBAction)showLogMessages:(id)sender;
- (void)writeError:(NSString*)err;
- (void)writeLog:(NSString*)str;
- (void)writeStatus:(NSString*)str;
@end

int writeError(id self, int err, ...);
void writeLog(id self, int log_lvl, int msg_lvl, char *str, ...);
void writeStatus(id self, char *status);
