/* $Id: HymnWindow.m,v 1.1 2004/05/10 00:16:59 playfair Exp $
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License as
** published by the Free Software Foundation; either version 2 of the
** License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful, but
** WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
** 02111-1307, USA.
*/

#import "HymnWindow.h"

@implementation HymnWindow
- (id)initWithContentRect:(NSRect)contentRect styleMask:(unsigned int)styleMask
	backing:(NSBackingStoreType)backingType defer:(BOOL)flag
{
	[super initWithContentRect: contentRect styleMask: styleMask backing: backingType
		defer: flag];
	[self registerForDraggedTypes:[NSArray arrayWithObjects:
            NSFilenamesPboardType, nil]];
	return self;
}

- (NSDragOperation)draggingEntered:(id <NSDraggingInfo>)sender {
    NSPasteboard *pboard;
    NSDragOperation sourceDragMask;

    sourceDragMask = [sender draggingSourceOperationMask];
    pboard = [sender draggingPasteboard];

    if ( [[pboard types] containsObject:NSFilenamesPboardType] ) {
		return NSDragOperationCopy;
	}

    return NSDragOperationNone;
}

- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender {
    NSPasteboard *pboard;
    NSDragOperation sourceDragMask;

    sourceDragMask = [sender draggingSourceOperationMask];
    pboard = [sender draggingPasteboard];

    if ( [[pboard types] containsObject:NSFilenamesPboardType] ) {
        NSArray *files = [pboard propertyListForType:NSFilenamesPboardType];

		[controller setFiles:files];
	}

    return YES;
}

@end
